!
subroutine DF19(X, Y, XX, DY, Error)
!   DY  Y(X)
!    X1 ... XN   .
real, intent(in):: X(:), Y(:), XX
real:: DY, H, H2, Ym, Ymm, Yn, Yp, Ypp, P
integer:: Error, k, n, L, R
!begin
  n=size(X)
  if(n<5) then
    Error=65; return
  end if
  Error=0
  H=X(2)-X(1); H2=2.0*H
  if(XX<=X(3)) then
    P=(XX-X(3))/H
    Ymm=Y(1); Ym=Y(2); Yn=Y(3); Yp=Y(4); Ypp=Y(5)
  else if(XX>=X(n-2)) then
    P=(XX-X(n-2))/H
    Ymm=Y(n-4); Ym=Y(n-3); Yn=Y(n-2); Yp=Y(n-1); Ypp=Y(n)
  else
    L=3; R=n-2
    do while(L+1<R)
      k=(L+R)/2
      if(X(k)<=XX) then; L=k
                   else; R=k
      end if
    end do
    if(XX-X(L) <= X(R)-XX) then
      P=(XX-X(L))/H
      Ymm=Y(L-2); Ym=Y(L-1); Yn=Y(L); Yp=Y(R); Ypp=Y(R+1)
    else
      P=(XX-X(R))/H
      Ymm=Y(L-1); Ym=Y(L); Yn=Y(R); Yp=Y(R+1); Ypp=Y(R+2)
    end if
  end if
  DY=-(((4.0*P-3.0)*P-8.0)*P+4.0)*Ym/3.0    &
     -(((4.0*P+3.0)*P-8.0)*P-4.0)*Yp/3.0    &
     +(((2.0*P-3.0)*P-1.0)*P+1.0)*Ymm/6.0    &
     +(((2.0*P+3.0)*P-1.0)*P-1.0)*Ypp/6.0    &
     +(2.0*P*P-5.0)*P*Yn
  DY=DY/H2
  return
end subroutine DF19
